require 'common/runner'
require 'prune/plugins/postfixadmin'
require 'rm/rm_dummy_runner'

class PruneDummyRunner
  include Runner

  def run(cfg, plugin)
    # We don't want to check the PostfixAdmin database against itself.
    return if plugin.class == PostfixadminPrune

    pfa = PostfixadminPrune.new(cfg)

    db_users = pfa.list_users()
    db_domains = pfa.list_domains()

    leftovers  = plugin.get_leftover_users(db_users)
    leftovers += plugin.get_leftover_domains(db_domains)

    rm_dummy_runner = RmDummyRunner.new()
    rm_dummy_runner.run(cfg, plugin, *leftovers)
  end

end
