require 'rm/rm_plugin'

module PrunePlugin
  #
  # Plugins for the removal of leftover non-PostfixAdmin users,
  # i.e. after an user has been removed from the PostfixAdmin
  # database.
  #
  extend Plugin::Run

  def self.runner()
    return PruneRunner
  end

  def self.dummy_runner
    return PruneDummyRunner
  end

  def get_leftover_domains(db_domains)
    # Given a list of domains, determine which domains belonging to
    # this plugin are not contained in the given list.

    # WARNING! Array difference doesn't work for some reason.
    return list_domains().select{ |d| !db_domains.include?(d) }
  end

  def get_leftover_users(db_users)
    # Given a list of users, determine which users belonging to
    # this plugin are not contained in the given list.

    # WARNING! Array difference doesn't work for some reason.
    return list_users().select{ |u| !db_users.include?(u) }
  end
end
